<?php
$hostname = 'https://cetakrapor.smkbpm.sch.id';
$dataFolder = 'data/';
$outputFolder = './'; // Folder untuk output HTML
$templateFile = __DIR__ . '/anonymous24.php';

$limitPerRun = 500;
$page = isset($_GET['page']) ? (int)$_GET['page'] : 1;
$startIndex = ($page - 1) * $limitPerRun;

ini_set('max_execution_time', 300);
ini_set('memory_limit', '1024M');

$template = file_get_contents($templateFile);
$files = glob($dataFolder . '*.txt');
$totalFiles = count($files);
$files = array_slice($files, $startIndex, $limitPerRun);

$urls = [];
$linkArray = [];

foreach ($files as $file) {
    $slug = basename($file, '.txt');
    $lines = file($file, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
    if (count($lines) < 2) continue;

    $title = str_replace("Title: ", "", $lines[0]);
    $description = str_replace("Description: ", "", $lines[1]);

    $internalLinks = '';
    $canonical = "$hostname/$slug.html";

    $content = str_replace(
        ['{{brand}}', '{{title}}', '{{description}}', '{{internalLinks}}', '{{canonical}}'],
        [$slug, $title, $description, $internalLinks, $canonical],
        $template
    );

    file_put_contents($outputFolder . "$slug.html", $content);
    $urls[] = $canonical;
    $linkArray[] = "<a href='$slug.html'>$title</a>";
}

// Update internal links
foreach ($files as $file) {
    $slug = basename($file, '.txt');
    $htmlPath = $outputFolder . "$slug.html";
    if (!file_exists($htmlPath)) continue;

    $html = file_get_contents($htmlPath);
    $internalLinks = implode(" | ", array_diff($linkArray, ["<a href='$slug.html'>$title</a>"]));
    $html = str_replace("{{internalLinks}}", $internalLinks, $html);
    file_put_contents($htmlPath, $html);
}

// Sitemap original format
function createSitemap($urls, $outputFolder, $hostname) {
    $date = date('Y-m-d');
    $xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
    $xml .= "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
    foreach ($urls as $url) {
        $xml .= "  <url>\n";
        $xml .= "    <loc>$url</loc>\n";
        $xml .= "    <lastmod>$date</lastmod>\n";
        $xml .= "    <changefreq>daily</changefreq>\n";
        $xml .= "    <priority>1.0</priority>\n";
        $xml .= "  </url>\n";
    }
    $xml .= "</urlset>";
    file_put_contents($outputFolder . 'sitemap.xml', $xml);
}

function createRobotsTxt($hostname, $outputFolder) {
    $robots = "User-agent: *\nAllow: /\nSitemap: $hostname/sitemap.xml";
    file_put_contents($outputFolder . 'robots.txt', $robots);
}

createSitemap($urls, $outputFolder, $hostname);
createRobotsTxt($hostname, $outputFolder);

echo "✅ Deploy selesai untuk " . count($files) . " file dari total $totalFiles.<br>";
if ($startIndex + $limitPerRun < $totalFiles) {
    echo "Lanjut halaman selanjutnya: <a href='?page=" . ($page+1) . "'>deploy.php?page=" . ($page+1) . "</a>";
}
?>
